package forms

type GetGrandmasterReq struct {
	Playerid int64 `form:"playerid" json:"playerid" binding:"required"`
}

type SetGrandmasterDanScoreReq struct {
	Playerid int64 `form:"playerid" json:"playerid" binding:"required"`
	DanScore int64 `json:"danScore"`
}

// GrandmasterReportReq 报表
type GrandmasterReportReq struct {
	ChannelId string `json:"channel_id" form:"channel_id"`
	Day       string `form:"day"`
	EndDay    string `form:"endDay"`
	Page      int    `form:"page"`
	PerPage   int    `form:"pageSize"`
	ServerId  int    `json:"server_id" form:"server_id"`
}

// GrandmasterWavesReq
type GrandmasterWavesReq struct {
	Date       int64  `form:"date"`
	ChannelId  string `json:"channel_id" form:"channel_id"`
	StartWaves int32  `form:"startWaves"`
	EndWaves   int32  `form:"endWaves"`
	Page       int    `form:"page"`
	PerPage    int    `form:"pageSize"`
	ServerId   int    `json:"server_id" form:"server_id"`
}

type GrandmasterSecondsReq struct {
	Date         int64  `form:"date"`
	ChannelId    string `json:"channel_id" form:"channel_id"`
	StartSeconds int32  `form:"startSeconds"`
	EndSeconds   int32  `form:"endSeconds"`
	Page         int    `form:"page"`
	PerPage      int    `form:"pageSize"`
	ServerId     int    `json:"server_id" form:"server_id"`
}

type GrandmasterDanReq struct {
	Date      int64  `form:"date"`
	ChannelId string `json:"channel_id" form:"channel_id"`
	Page      int    `form:"page"`
	PerPage   int    `form:"pageSize"`
	ServerId  int    `json:"server_id" form:"server_id"`
}

type GrandmasterMatchReq struct {
	StartSeconds int32 `form:"startSeconds"`
	EndSeconds   int32 `form:"endSeconds"`
	Type         int32 `form:"type"`
}
