package forms

// TreasureReportReq 宝物报表
type TreasureReportReq struct {
	ChannelId string `json:"channel_id" form:"channel_id"`
	Day       string `form:"day"`
	EndDay    string `form:"endDay"`
	Page      int    `form:"page"`
	PerPage   int    `form:"pageSize"`
	ServerId  int    `json:"server_id" form:"server_id"`
}

// TreasurePlayerLevelReq 宝物玩家等级拥有
type TreasurePlayerLevelReq struct {
	ChannelId  string `json:"channel_id" form:"channel_id"`
	StartLevel int32  `form:"startLevel"`
	EndLevel   int32  `form:"endLevel"`
	Page       int    `form:"page"`
	PerPage    int    `form:"pageSize"`
	ServerId   int    `json:"server_id" form:"server_id"`
}

// TreasureLevelReq 宝物等级
type TreasureLevelReq struct {
	ChannelId  string `json:"channel_id" form:"channel_id"`
	StartLevel int64  `form:"startLevel"`
	EndLevel   int64  `form:"endLevel"`
	Page       int    `form:"page"`
	PerPage    int    `form:"pageSize"`
	ServerId   int    `json:"server_id" form:"server_id"`
}

// TreasureStarReq 宝物星级
type TreasureStarReq struct {
	ServerId int `json:"server_id" form:"server_id"`
}
