package consts

// 三位数错误编码为复用http原本含义
// 五位数错误编码为应用自定义错误
// 五开头的五位数错误编码为服务器端错误，比如数据库操作失败
// 四开头的五位数错误编码为客户端错误，有时候是客户端代码写错了，有时候是用户操作错误
const (
	// CodeSuccess 操作成功
	CodeSuccess = 0
	// CodeCheckLogin 未登录
	CodeCheckLogin = 401
	// CodeNoPermission 无权限
	CodeNoPermission = 402
	// CodeNoRightErr 未授权访问
	CodeNoRightErr = 403
	// CodeDBError 数据库操作失败
	CodeDBError = 50001
	// CodeEncryptError 加密失败
	CodeEncryptError = 50002
	//CodeParamErr 各种奇奇怪怪的参数错误
	CodeParamErr = 40001
	//CodePanicErr 致命错误
	CodePanicErr = 41001
)
