package forms

type LimitGiftListReq struct {
	ChannelId string `json:"channel_id" form:"channel_id"`
	Day       string `form:"day"`
	EndDay    string `form:"endDay"`
	Page      int64  `json:"page" form:"page"`
	PerPage   int64  `json:"pageSize"  form:"pageSize"`
	ServerId  int    `json:"server_id" form:"server_id"`
}

type LimitGiftListItem struct {
	ID              int32  `json:"id"`
	GoodsType       string `json:"type"`
	GoodsValue      string `json:"value"`
	AllTriggerCount int64  `json:"allTriggerCount"`
	ShowCount       int64  `json:"showCount"`
	PayCount        int64  `json:"payCount"`
}

type LimitGiftListRespData struct {
	Code  int32                `json:"code"`
	Msg   string               `json:"msg"`
	Data  []*LimitGiftListItem `json:"data"`
	Total int64                `json:"total"`
}
