package constants

const ERR_OK = 0
const ERR_REQUEST_CONENT = 1
const ERR_PARAM = 2
const ERR_SIG = 3
const ERR_SYS = 4
const ERR_PAY_NOTEXISTS = 5
const ERR_PAY_FAILURE = 6
const ERR_SIGIN_ALREADY = 7
const ERR_SIGIN_TREASURE_NOTENOUGH = 8
const ERR_OUT_GAME_TIME = 9
const ERR_OUT_GAME_TIME_LEN = 10
const ERR_NO_BIND_IDCARD = 11
const ERR_EXISTS = 12
const ERR_NOTEXISTS = 13

const ERR_INVITE_PRIZE_ALREADY = 22
const ERR_INVITE_CONDITION = 23

const ERR_PLAY_STAGE_ERROR = 24
const ERR_REQUEST_IP_FORBID = 25
const ERR_SHARE_LIMIT = 26

const ERR_PLAY_RESULT_INVITE_CD = 31
const ERR_PLAY_RESULT_INVITE_DECRYPT = 32

const ERR_ONLINEPRIZE_GETED = 34
const ERR_ONLINEPRIZE_PARAM = 35

const ERR_LOTTERY_MAX_TIMES = 36

const ERR_GAME_EXCHANGE_HAS = 101
const ERR_GAME_THEME_HASNT = 102
const ERR_GAME_THEME_ELEMENT_HASNT = 103
const ERR_GAME_THEME_NOTEXISTS = 104
const ERR_GAME_THEME_GETTED = 105
const ERR_GAME_ELEMENT_NOTEXISTS = 106
const ERR_GAME_ELEMENT_MATERIAL_NOTENOUGH = 107
const ERR_GAME_THEME_MATERIAL_NOTENOUGH = 108

const ERR_GAME_SHARE_ITEM_ERROR = 109
const ERR_GAME_SHARE_ITEM_GETTED = 110

// var (
// 	ErrBindingNotFound                = errors.New("binding for this user was not found in etcd")
// 	ErrBrokenPipe                     = errors.New("broken low-level pipe")
// 	ErrBufferExceed                   = errors.New("session send buffer exceed")
// 	ErrChangeDictionaryWhileRunning   = errors.New("you shouldn't change the dictionary while the app is already running")
// 	ErrChangeRouteWhileRunning        = errors.New("you shouldn't change routes while app is already running")
// 	ErrCloseClosedGroup               = errors.New("close closed group")
// 	ErrCloseClosedSession             = errors.New("close closed session")
// 	ErrClosedGroup                    = errors.New("group closed")
// 	ErrEmptyUID                       = errors.New("empty uid")
// 	ErrEtcdGrantLeaseTimeout          = errors.New("timed out waiting for etcd lease grant")
// 	ErrEtcdLeaseNotFound              = errors.New("etcd lease not found in group")
// 	ErrFrontSessionCantPushToFront    = errors.New("frontend session can't push to front")
// 	ErrFrontendTypeNotSpecified       = errors.New("for using SendPushToUsers from a backend server you have to specify a valid frontendType")
// 	ErrGroupAlreadyExists             = errors.New("group already exists")
// 	ErrGroupNotFound                  = errors.New("group not found")
// 	ErrIllegalUID                     = errors.New("illegal uid")
// 	ErrInvalidCertificates            = errors.New("certificates must be exactly two")
// 	ErrInvalidSpanCarrier             = errors.New("tracing: invalid span carrier")
// 	ErrKickingUsers                   = errors.New("failed to kick users, check array with failed uids")
// 	ErrMemberAlreadyExists            = errors.New("member already exists in group")
// 	ErrMemberNotFound                 = errors.New("member not found in the group")
// 	ErrMemoryTTLNotFound              = errors.New("memory group TTL not found")
// 	ErrMetricNotKnown                 = errors.New("the provided metric does not exist")
// 	ErrNatsMessagesBufferSizeZero     = errors.New("pitaya.buffer.cluster.rpc.server.nats.messages cant be zero")
// 	ErrNatsNoRequestTimeout           = errors.New("pitaya.cluster.rpc.client.nats.requesttimeout cant be empty")
// 	ErrNatsPushBufferSizeZero         = errors.New("pitaya.buffer.cluster.rpc.server.nats.push cant be zero")
// 	ErrNilCondition                   = errors.New("pitaya/timer: nil condition")
// 	ErrNoBindingStorageModule         = errors.New("for sending remote pushes or using unique session module while using grpc you need to pass it a BindingStorage")
// 	ErrNoConnectionToServer           = errors.New("rpc client has no connection to the chosen server")
// 	ErrNoContextFound                 = errors.New("no context found")
// 	ErrNoNatsConnectionString         = errors.New("you have to provide a nats url")
// 	ErrNoServerTypeChosenForRPC       = errors.New("no server type chosen for sending RPC, send a full route in the format server.service.component")
// 	ErrNoServerWithID                 = errors.New("can't find any server with the provided ID")
// 	ErrNoServersAvailableOfType       = errors.New("no servers available of this type")
// 	ErrNoUIDBind                      = errors.New("you have to bind an UID to the session to do that")
// 	ErrNonsenseRPC                    = errors.New("you are making a rpc that may be processed locally, either specify a different server type or specify a server id")
// 	ErrNotImplemented                 = errors.New("method not implemented")
// 	ErrNotifyOnRequest                = errors.New("tried to notify a request route")
// 	ErrOnCloseBackend                 = errors.New("onclose callbacks are not allowed on backend servers")
// 	ErrProtodescriptor                = errors.New("failed to get protobuf message descriptor")
// 	ErrPushingToUsers                 = errors.New("failed to push message to users, check array with failed uids")
// 	ErrRPCClientNotInitialized        = errors.New("RPC client is not running")
// 	ErrRPCJobAlreadyRegistered        = errors.New("rpc job was already registered")
// 	ErrRPCLocal                       = errors.New("RPC must be to a different server type")
// 	ErrRPCServerNotInitialized        = errors.New("RPC server is not running")
// 	ErrReplyShouldBeNotNull           = errors.New("reply must not be null")
// 	ErrReplyShouldBePtr               = errors.New("reply must be a pointer")
// 	ErrRequestOnNotify                = errors.New("tried to request a notify route")
// 	ErrRouterNotInitialized           = errors.New("router is not initialized")
// 	ErrServerNotFound                 = errors.New("server not found")
// 	ErrServiceDiscoveryNotInitialized = errors.New("service discovery client is not initialized")
// 	ErrSessionAlreadyBound            = errors.New("session is already bound to an uid")
// 	ErrSessionDuplication             = errors.New("session exists in the current group")
// 	ErrSessionNotFound                = errors.New("session not found")
// 	ErrSessionOnNotify                = errors.New("current session working on notify mode")
// 	ErrTimeoutTerminatingBinaryModule = errors.New("timeout waiting to binary module to die")
// 	ErrWrongValueType                 = errors.New("protobuf: convert on wrong type value")
// 	ErrRateLimitExceeded              = errors.New("rate limit exceeded")
// 	ErrReceivedMsgSmallerThanExpected = errors.New("received less data than expected, EOF?")
// 	ErrReceivedMsgBiggerThanExpected  = errors.New("received more data than expected")
// 	ErrConnectionClosed               = errors.New("client connection closed")
// )
