package model

const (
	// 1 体力 2 挑战者卷轴 3 精力 4 神秘卷轴
	StaminaType = 1
	DefierType  = 2
	EnergyType  = 3
	MysteryType = 4
)

type TicketInfo struct {
	Uid          int    `json:"UId"`          // 门票编号 1 体力 2 挑战者卷轴 3 精力 4 神秘卷轴
	Name         string `json:"Name"`         // 门票名称
	RestoreMax   int64  `json:"RestoreMax"`   // 恢复上限
	InitNum      int64  `json:"InitNum"`      // 初始数量
	RestoreSpeed int64  `json:"RestoreSpeed"` // 恢复速度
	GetType      int    `json:"GetType"`      // 1 1：自动增加 2 2：手动领取
	ItemID       int    `json:"ItemId"`       // 道具ID
	Price        int    `json:"Price"`        // 价格钻石
	BuyCount     int    `json:"Quota"`        // 次数
	Single       int    `json:"Single"`       // 单次购买数
	AdBuyID      int    `json:"AdBuyID"`      // 广告点购买ID  	-1：没有
	AdBuyNum     int    `json:"AdBuyNum"`     // 广告购买次数
}
