package msg

type LevelChanged struct {
	PlayerId int64 `json:"userId"`
	Level    int   `json:"level"`
	ServerId int   `json:"serverId"`
}

type LastLoginServer struct {
	PlayerId int64 `json:"userId"`
	ServerId int   `json:"serverId"`
	Level    int   `json:"level"`
}

type BanUser struct {
	PlayerId int64  `json:"userId"`
	AccId    int64  `json:"accId"`
	Ban      int    `json:"ban"`    // 1拉黑 0解除拉黑 2只上报记录不拉黑
	Reason   string `json:"reason"` // 拉黑原因
	Time     int64  `json:"time"`   // 拉黑时间
}

type AvatarUrlChanged struct {
	AccId     int64  `json:"accId"`
	AvatarUrl string `json:"AvatarUrl"`
	Nick      string `json:"Nick"`
}

// GameDataAlarm
type GameDataAlarm struct {
	PlayerId int64  `json:"playerId"` // 玩家ID
	Attrs    []int  `json:"attrs"`    // 错误属性
	Msg      string `json:"msg"`      // 错误详情
	Time     int64  `json:"created"`  // 触发时间
	ServerId int    `json:"serverId"` // 几服
	Module   string `json:"module"`   // 触发模块
}

type GmDelAccountId struct {
	MsgId string `json:"msgId"`
	AccId int64  `json:"accId"`
}

type ResponseGmDelAccountId struct {
	ErrCode int    `json:"errCode"`
	MsgId   string `json:"msgId"`
}
